﻿-- ShoppingList
-- by Zreptil

-- global saved variables
SLPlayer = nil
SLSlots = nil
SLChars = nil

-- local variables
SLMaxSlots = 60
SLDragSlot = nil
SLSaveSlot = nil
SLSkipEvents = false
SL_MailButton = nil

function SL_GetCharId()
  return UnitName("player").." of "..GetCVar("realmName")
--  return "Zuthor".." of "..GetCVar("realmName")
end

function SL_GetCharName()
  return UnitName("player").." "..SLNames["textOf"].." "..GetCVar("realmName")
--  return "Zuthor".." "..SLNames["textOf"].." "..GetCVar("realmName")
end

-------------------------------------------------------------------------
--
-- recreate the saved variables
--
-------------------------------------------------------------------------
function SL_Reset(bForce)
  local playerName = SL_GetCharId()
  
  if SLChars[SL_GetCharId()] ~= nil then
    SLPlayer = SLChars[SL_GetCharId()]
  end
  
  if bForce or  SLPlayer == nil then
    SLPlayer =
    {
      ["Version"] = SLVarVersion;
      ["AutoShow"] = true;
      ["SuppressDouble"] = true;
			["HandleMail"] = false;
      ["CurrentGroup"] = "1";
    }

    SLSlots = {}
    local i = 1
    for i=1, SLMaxSlots, 1 do
      SL_ClearSlot(i)
    end
  else
    if SLPlayer["CurrentGroup"] == nil then
      SLPlayer["CurrentGroup"] = "1"
    end
    
    SL_Update()
    
    SLSlots = SLPlayer["groups"][SLPlayer["CurrentGroup"]..""]
    for i=1, SLMaxSlots, 1 do
      if SLSlots[i] == nil then
        SL_ClearSlot(i)
      end
    end
  end
  
  if SLPlayer["sendmail"] == nil then
    SLPlayer["sendmail"] = {}
  end

  SLChars[SL_GetCharId()] = SLPlayer
end

function SL_ClearSlot(iSlotId)
  SLSlots[iSlotId] = {}
  SLSlots[iSlotId]["item"] = ""
  SLSlots[iSlotId]["npc"] = {}
  SLSlots[iSlotId]["npc"]["name"] = ""
  SLSlots[iSlotId]["npc"]["zone"] = ""
  SLSlots[iSlotId]["npc"]["subzone"] = ""
  SLSlots[iSlotId]["npc"]["posx"] = 0
  SLSlots[iSlotId]["npc"]["posy"] = 0
  SLSlots[iSlotId]["tip"] = ""
  SLSlots[iSlotId]["costs"] = {}
  SLSlots[iSlotId]["costs"]["money"] = 0
  SLChars[SL_GetCharId()] = SLPlayer
end
-------------------------------------------------------------------------
--
-- executed when addon is loaded
--
-------------------------------------------------------------------------
function SL_OnLoad()
  SlashCmdList["SHOPPINGLIST"] = function(msg) SL_SlashHandler(msg) end
  SLASH_SHOPPINGLIST1 = "/shoppinglist"
  SLASH_SHOPPINGLIST2 = "/sl"

	SL_MailButton = CreateFrame("Button", "SLMailButton", SendMailFrame)
	SL_MailButton:SetWidth(30)
	SL_MailButton:SetHeight(30)
	SL_MailButton:SetPoint("TOPRIGHT", -5, -15)
	SL_MailButton:SetNormalTexture("Interface\\BUTTONS\\Button-Backpack-Up")
	SL_MailButton:SetHighlightTexture("Interface\\BUTTONS\\ButtonHilight-Round")
	SL_MailButton:SetPushedTexture("Interface\\ChatFrame\\ButtonHilight-Square")
  SL_MailButton:RegisterForClicks("AnyUp", "AnyDown")
	SL_MailButton:SetScript("OnEnter", 
    function(self)
      GameTooltip:SetOwner(self,"ANCHOR_TOPLEFT")
      GameTooltip:SetBackdropColor(0.0,0.0,0.0)
      GameTooltip:SetText(format(SLToolTips[self:GetName()],SendMailNameEditBox:GetText()),0.8,0.8,0.0)
    end)
	SL_MailButton:SetScript("OnLeave", 
    function(self)
      GameTooltip:Hide()
    end)
	SL_MailButton:SetScript("OnClick", 
    function(self, button, down)
      if button == "LeftButton" then
        receiver = SendMailNameEditBox:GetText()
        SLSkipEvents = true
        if SLPlayer["sendmail"][receiver] ~= nil then
          for bagId = 0, NUM_BAG_SLOTS, 1 do
            for slotId = 1, GetContainerNumSlots(bagId), 1 do
              item = GetContainerItemID(bagId,slotId)
              if item ~= nil then
                item = GetItemInfo(item)
                if SLPlayer["sendmail"][receiver][item] ~= nil then
                  UseContainerItem(bagId, slotId)
                end
              end 
            end
          end
        end
        SLSkipEvents = false
      elseif button == "RightButton" then
        SLPlayer["sendmail"][receiver] = nil
        message(format(SLMessages["SLMailCleared"],SendMailNameEditBox:GetText()))
      end
  	end)
    
  ShoppingList:RegisterEvent("PLAYER_LOGIN")
  ShoppingList:RegisterEvent("PLAYER_LEAVING_WORLD")
  ShoppingList:RegisterEvent("MERCHANT_SHOW")
  ShoppingList:RegisterEvent("MERCHANT_CLOSED")
  ShoppingList:RegisterEvent("ITEM_LOCK_CHANGED")
  ShoppingList:RegisterEvent("MAIL_SEND_INFO_UPDATE")
end

-------------------------------------------------------------------------
--
-- for debugging purposes
--
-------------------------------------------------------------------------
function SL_Debug(msg)
  if doDebug and DEFAULT_CHAT_FRAME then
    DEFAULT_CHAT_FRAME:AddMessage("<ShoppingListDebug> "..msg, 1.0, 1.0, 0.0)
  end
end

function SL_Update()
  -- Uebernahme von alter Datenstruktur in neue
  if SLPlayer["groups"] == nil then
    SLPlayer["groups"] = {}
    SLPlayer["groups"][SLPlayer["CurrentGroup"]..""] = SLPlayer["slots"]
    SLPlayer["slots"] = nil
  end
end

-------------------------------------------------------------------------
--
-- initialization
--
-------------------------------------------------------------------------
function SL_Initialize()
  if SLChars == nil then
    SLChars = {}
  end

  if      SLPlayer == nil
      or (   ( not SLPlayer.Version )
          or ( SLPlayer.Version ~= SLVarVersion )
         )
    then
    SL_Reset(true)
    SL_Chat(SLMessages["SLNewLoaded"])
  else
    SL_Reset(false)
  end
  
  SL_Update()
  
  if SLPlayer["CurrentGroup"] == nil then
    SLPlayer["CurrentGroup"] = "1"
  end
  
  SL_ChangeGroup(SLPlayer["CurrentGroup"])

	if SLPlayer["HandleMail"] then
		SL_MailButton:Show()
	else
		SL_MailButton:Hide()
	end
  SLChars[SL_GetCharId()] = SLPlayer
end

-------------------------------------------------------------------------
--
-- deinitialization, called before the variables are saved
--
-------------------------------------------------------------------------
function SL_Deinitialize()
  for i=1, SLMaxSlots, 1 do
    if SLSlots[i] ~= nil and SLSlots[i]["item"] == "" then
      SLSlots[i] = nil
    end
  end
  SLPlayer["groups"][SLPlayer["CurrentGroup"]..""] = SLSlots
  SLChars[SL_GetCharId()] = SLPlayer
end

-------------------------------------------------------------------------
--
-- eventhandler
--
-------------------------------------------------------------------------
function SL_OnEvent(event)
  if SLSkipEvents then
    return
  end 
   
  if event == "PLAYER_LOGIN" then
    local playerName = UnitName("player")
    if   (    playerName ~= UNKNOWNBEING
          and playerName ~= "Unknown Entity"
         )
      or SLPlayer == nil
      or SLChars == nil
    then
      SL_Chat(SLMessages["SLLoaded"])
      SL_Initialize()
    end
  elseif event == "PLAYER_LEAVING_WORLD" then
    SL_Deinitialize()
  elseif event == "MERCHANT_SHOW" then
    if SLPlayer["AutoShow"] then
      _G["SLFrame"]:Show()
    end
  elseif event == "MERCHANT_CLOSED" then
    if SLPlayer["AutoShow"] then
      _G["SLFrame"]:Hide()
    end
  elseif event == "ITEM_LOCK_CHANGED" then
    SLDragSlot = nil
    SLSaveSlot = nil
  elseif event == "MAIL_SEND_INFO_UPDATE" then
    if SLPlayer["HandleMail"] then
			receiver = SendMailNameEditBox:GetText()
      if SLPlayer["sendmail"] == nil then
				SLPlayer["sendmail"] = {}
      end
			if SLPlayer["sendmail"][receiver] == nil then
				SLPlayer["sendmail"][receiver] = {}
			end
			for iSlotId=1, 12, 1 do
				local item = GetSendMailItem(iSlotId)
				if    item ~= nil 
				  and (   SLPlayer["sendmail"][receiver][item] == nil 
					     or not SLPlayer["sendmail"][receiver][item]
							) then
					SLPlayer["sendmail"][receiver][item] = true
--					SL_Chat(format(SLMessages["SLMailItemAdded"],item,receiver))
				end
			end
		end
    SLChars[SL_GetCharId()] = SLPlayer
  end
end

-------------------------------------------------------------------------
--
-- executed when a slashcommand is entered
--
-------------------------------------------------------------------------
function SL_SlashHandler(msg)
  if ( strlen(msg) == 0 ) then
    SL_Chat(SLMessages["slashhelp"])
    return
  end

  if ( strsub(msg,1,5) == "debug" ) then
    doDebug = not doDebug
  elseif ( msg == "reset" ) then
    SL_Reset(true)
  end
end

-------------------------------------------------------------------------
--
-- display a message in the normal chatwindow
--
-------------------------------------------------------------------------
function SL_Chat(msg)
  if DEFAULT_CHAT_FRAME then
    if doDebug then
      msg = "<ShoppingList> "..msg
    end
    DEFAULT_CHAT_FRAME:AddMessage(msg,0.9,0.7,0.0)
  end
end

-------------------------------------------------------------------------
--
-- eventhandler for the button at the minimap
--
-------------------------------------------------------------------------
function SL_FrameToggle(button)
  local frame

  if ( button == "LeftButton" ) then
    frame = _G["SLFrame"]
    if ( frame:IsVisible() ) then
      frame:Hide()
    else
      frame:Show()
    end
  end
end

-------------------------------------------------------------------------
--
-- make first letter of string uppercase
--
-------------------------------------------------------------------------
function SL_FirstLetterBig(text)
  return strupper(strsub(text,1,1))..strsub(text,2)
end

-------------------------------------------------------------------------
--
-- reads a text from the config and sets it to the control
--
-------------------------------------------------------------------------
function SL_SetText(control)
  if not SLPlayer then
    return
  end

  _G[control]:SetText(SLNames[control])
end

-------------------------------------------------------------------------
--
-- fill the controls on the listdialog
--
-------------------------------------------------------------------------
function SL_FillConfig()
  SL_SetText("SLTitle")
  SL_SetText("SLClose")
  _G["SLChar"]:SetText(SL_GetCharName())

  local slotFrame = _G["SLFrame"]
  local x = 24
  local y = -36
  local size = 32
  local space = 4

  for iSlotId=1, SLMaxSlots, 1 do
    local v = SLSlots[iSlotId]
    if _G["slot"..iSlotId] == nil then
      ctrl = CreateFrame("Button","slot"..iSlotId,slotFrame,"SLItemTemplate")
      ctrl:SetWidth(size)
      ctrl:SetHeight(size)
      ctrl:SetPoint("TOPLEFT",x,y)
      x = x + size + space
      if x > slotFrame:GetWidth()-size then
        x = 24
        y = y - size - space
      end
    end
    SL_UpdateSlot(iSlotId)
  end
end

-------------------------------------------------------------------------
--
-- Save the settings to the player
--
-------------------------------------------------------------------------
function SL_SaveConfig()
end

-------------------------------------------------------------------------
--
-- set the texture to a slot
--
-------------------------------------------------------------------------
function SL_SetTexture(ctrl,type)
  local x = 0
  local y = 1
  if type == "empty" then
    type = "Interface\\Buttons\\UI-Slot-Background"
    y = 0.640625
  end
  ctrl:SetNormalTexture(type)
  ctrl:SetHighlightTexture(type)
  ctrl:GetNormalTexture():SetTexCoord(x,y,x,y)
  ctrl:GetHighlightTexture():SetTexCoord(x,y,x,y)
end

-------------------------------------------------------------------------
--
-- update the display of an item in a slot
--
-------------------------------------------------------------------------
function SL_UpdateSlot(iSlotId)
  local ctrl = _G["slot"..iSlotId]

  if ctrl ~= nil and SLSlots[iSlotId] ~= nil then
    icon = GetItemIcon(SLSlots[iSlotId]["item"])
    if icon ~= nil then
      SL_SetTexture(ctrl,icon)
      if SLSlots[iSlotId]["showcount"] ~= nil then
        count = GetItemCount(SLSlots[iSlotId]["item"], false, false)
        ctrl:SetText(count)
      end
      if SLDragSlot ~= nil then
        if SLDragSlot ~= iSlotId then
          ctrl = _G["slot"..SLDragSlot]
          if ctrl ~= nil then
            SL_ClearSlot(SLDragSlot)
            SL_SetTexture(ctrl,"empty")
          end
        end
        SLDragSlot = nil
      end
    else
      SL_SetTexture(ctrl,"empty")
    end
  end
end

---------------------------------------------------------------------------
----
---- mouse up on a slot
----
---------------------------------------------------------------------------
--function SL_ItemOnMouseUp( frame )
--  local iSlotId = tonumber(strsub(frame:GetName(),5))
--
--  if SLDragSlot ~= nil then
--    ClearCursor()
--    if SLSlots[iSlotId]["item"] ~= nil then
--      local slot = SLSlots[iSlotId]
--      SLSlots[iSlotId] = SLSlots[SLDragSlot]
--      SLSlots[SLDragSlot] = slot
--      id = SLDragSlot
--      SLDragSlot = nil
--      SL_UpdateSlot(iSlotId)
--      SL_UpdateSlot(id)
--    else
--      SLSlots[iSlotId] = SLSlots[SLDragSlot]
--      SL_UpdateSlot(iSlotId)
--    end
--  else
--    local infoType, itemId, itemLink = GetCursorInfo()
--    if infoType == "merchant" then
--      ClearCursor()
--      itemLink = GetMerchantItemLink(itemId)
--      SLSlots[iSlotId]["item"] = itemLink
--      SL_UpdateSlot(iSlotId)
--    elseif SLSlots[iSlotId]["item"] ~= "" then
--      ClearCursor()
--      PickupItem(SLSlots[iSlotId]["item"])
--      SLDragSlot = iSlotId
--    end
--  end
--end

-------------------------------------------------------------------------
--
-- check if item is already in shoppinglist
-- nil = if the item is not found
-- 1 = if the item is found but not in the slot iSlotId
-- 2 = if the item is found in the slot iSlotId
--
-------------------------------------------------------------------------
function SL_HasItem(itemLink,iSlotId)
  for idx=1, SLMaxSlots, 1 do
    if SLSlots[idx] ~= nil and SLSlots[idx]["item"] == itemLink then
      if idx == iSlotId then
        return 1
      else
        return 2
      end
    end
  end

  return nil
end

-------------------------------------------------------------------------
--
-- clicked on an item, will be shown in editline, if clicked with shift
--
-------------------------------------------------------------------------
function SL_ItemOnClick( frame )
  local iSlotId = tonumber(strsub(frame:GetName(),5))

  if (SLSlots[iSlotId] == nil or SLSlots[iSlotId]["item"] == "") and SLSaveSlot ~= nil and CursorHasItem() then
    SLSlots[iSlotId] = SLSaveSlot
    SLDragSlot = nil
    SL_UpdateSlot(iSlotId)
    ClearCursor()
    SLChars[SL_GetCharId()] = SLPlayer
  else
    HandleModifiedItemClick(SLSlots[iSlotId]["item"])
    SLSaveSlot = nil
    SLDragSlot = nil
    ClearCursor()
  end
end

-------------------------------------------------------------------------
--
-- something dragged to a slot
--
-------------------------------------------------------------------------
function SL_ItemOnReceive( frame )
  local infoType, itemId, itemLink = GetCursorInfo()
  local iSlotId = tonumber(strsub(frame:GetName(),5))
  local itemLink

  if infoType == "merchant" then
    sName, sTexture, iPrice, iNumAvailable, isUsable, hasExtendedCost = GetMerchantItemInfo(itemId)
    itemLink = GetMerchantItemLink(itemId)

    ClearCursor()

    local hasItem = SL_HasItem(itemLink,iSlotId)
    local addItem = true

    if SLPlayer["SuppressDouble"] then
      if hasItem then
        if hasItem == 1 then
          addItem = true
        else
          message(SLMessages["SLAlreadyThere"])
          addItem = false
        end
      end
    end

    if addItem then
      SL_ClearSlot(iSlotId)
      SLSlots[iSlotId]["item"] = itemLink
      SLSlots[iSlotId]["npc"]["name"] = UnitName("target")
      SLSlots[iSlotId]["npc"]["zone"] = GetRealZoneText()
      SLSlots[iSlotId]["npc"]["subzone"] = GetSubZoneText()
      local x,y = GetPlayerMapPosition("player")
      SLSlots[iSlotId]["npc"]["posx"] = floor(x*100+0.5)
      SLSlots[iSlotId]["npc"]["posy"] = floor(y*100+0.5)
      SLSlots[iSlotId]["costs"] = {}
      SLSlots[iSlotId]["costs"]["money"] = iPrice
      local iCount = GetMerchantItemCostInfo(itemId)
      local div = ""
      for i=1, iCount, 1 do
        local sTexture, iValue, costLink = GetMerchantItemCostItem(itemId,i)
        if iValue > 0 then
          SLSlots[iSlotId]["costs"]["value"..i] = iValue
          SLSlots[iSlotId]["costs"]["link"..i] = " |T"..sTexture..":0:0:2:-7|t"
        end
      end
    end
    GameTooltip:ClearLines()
    GameTooltip:SetMerchantItem(itemId)
    if GameTooltip:NumLines() > 0 then
      SLSlots[iSlotId]["tip"] = ""
      for i=1,GameTooltip:NumLines() do
        local line = _G["GameTooltipTextLeft"..i]:GetText()
        local bp1,ep1 = string.find(line,"pers\195\182nliche Arenawertung")
        local bp2,ep2 = string.find(line,"Teamwertung")
        if bp1 ~= nil or bp2 ~= nil then
          SLSlots[iSlotId]["tip"] = SLSlots[iSlotId]["tip"]..line
        end
      end
    end
  elseif SLDragSlot ~= nil then
    ClearCursor()
    if SLSlots[iSlotId] ~= nil and SLSlots[iSlotId]["item"] ~= nil and iSlotId ~= SLDragSlot then
      local slot = SLSlots[iSlotId]
      SLSlots[iSlotId] = SLSaveSlot
      SLSlots[SLDragSlot] = slot
      id = SLDragSlot
      SLDragSlot = nil
      SLSaveSlot = nil
      SL_UpdateSlot(iSlotId)
      SL_UpdateSlot(id)
    else
      SLSlots[iSlotId] = SLSaveSlot
      SLSaveSlot = nil
      SLDragSlot = nil
      SL_UpdateSlot(iSlotId)
    end
    SLDragSlot = nil
  elseif infoType == "-item" then
    local sName, itemLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetMerchantItemInfo(itemId)
    ClearCursor()
    SLClearSlot(iSlotId)
    SLSlots[iSlotId]["item"] = itemLink
    SL_Chat("Info: "..frame:GetName())
  elseif infoType == "item" then
    itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType,
    itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemId)

    ClearCursor()
    SLSaveSlot = nil
    SLDragSlot = nil
---------------------------------------------------------------------------------------------------    
    local hasItem = SL_HasItem(itemLink,iSlotId)
    local addItem = true

    if SLPlayer["SuppressDouble"] then
      if hasItem then
        if hasItem == 1 then
          addItem = true
        else
          message(SLMessages["SLAlreadyThere"])
          addItem = false
        end
      end
    end

    if addItem then
      SL_ClearSlot(iSlotId)
      SLSlots[iSlotId]["item"] = itemLink
--      SLSlots[iSlotId]["npc"]["name"] = UnitName("target")
--      SLSlots[iSlotId]["npc"]["zone"] = GetRealZoneText()
--      SLSlots[iSlotId]["npc"]["subzone"] = GetSubZoneText()
--      local x,y = GetPlayerMapPosition("player")
--      SLSlots[iSlotId]["npc"]["posx"] = floor(x*100+0.5)
--      SLSlots[iSlotId]["npc"]["posy"] = floor(y*100+0.5)
      SLSlots[iSlotId]["costs"] = {}
      SLSlots[iSlotId]["showcount"] = true
--      SLSlots[iSlotId]["costs"]["money"] = iPrice
--      local iCount = GetMerchantItemCostInfo(itemId)
--      local div = ""
--      for i=1, iCount, 1 do
--        local sTexture, iValue, costLink = GetMerchantItemCostItem(itemId,i)
--        if iValue > 0 then
--          SLSlots[iSlotId]["costs"]["value"..i] = iValue
--          SLSlots[iSlotId]["costs"]["link"..i] = " |T"..sTexture..":0:0:2:-7|t"
--        end
--      end
--    end
--    GameTooltip:ClearLines()
--    GameTooltip:SetMerchantItem(itemId)
--    if GameTooltip:NumLines() > 0 then
--      SLSlots[iSlotId]["tip"] = ""
--      for i=1,GameTooltip:NumLines() do
--        local line = _G["GameTooltipTextLeft"..i]:GetText()
--        local bp1,ep1 = string.find(line,"pers\195\182nliche Arenawertung")
--        local bp2,ep2 = string.find(line,"Teamwertung")
--        if bp1 ~= nil or bp2 ~= nil then
--          SLSlots[iSlotId]["tip"] = SLSlots[iSlotId]["tip"]..line
--        end
--      end
    end
---------------------------------------------------------------------------------------------------
  else
    ClearCursor()
    SLSaveSlot = nil
    SLDragSlot = nil
  end

  SL_UpdateSlot(iSlotId)
  SL_ItemOnEnter(frame)
  SLChars[SL_GetCharId()] = SLPlayer
end

-------------------------------------------------------------------------
--
-- mouse moved to a slot
--
-------------------------------------------------------------------------
function SL_ItemOnEnter( frame )
  local iSlotId = tonumber(strsub(frame:GetName(),5))
  
  if SLSlots[iSlotId] == nil then
  	return
  end
  
  local costs = SLSlots[iSlotId]["costs"]
  local infoNpc = ""
  local infoPos = ""
  local infoSubPos = ""
  local infoCost = ""
  local infoTip = ""

  if    SLSlots[iSlotId]["item"] ~= nil
    and SLSlots[iSlotId]["item"] ~= "" then
    
    if IsControlKeyDown() == nil then
      GameTooltip:SetOwner(_G["SLFrame"],"ANCHOR_LEFT",0,0)
      GameTooltip:SetHyperlink(SLSlots[iSlotId]["item"])
    end

    if    SLSlots[iSlotId]["npc"]["name"] ~= nil
      and SLSlots[iSlotId]["npc"]["zone"] ~= nil
      and SLSlots[iSlotId]["npc"]["subzone"] ~= nil then
      local x = SLSlots[iSlotId]["npc"]["posx"]
      local y = SLSlots[iSlotId]["npc"]["posy"]
      colNpc = "00ff00"
      colPos = "ffe060"
      colSubPos = "ff2060"
      colTxt = "ffffff"
      infoNpc = "|cff"..colNpc..SLSlots[iSlotId]["npc"]["name"]
      infoPos = infoPos.."|cff"..colPos..SLSlots[iSlotId]["npc"]["zone"]
      infoSubPos = infoSubPos.."|cff"..colSubPos..SLSlots[iSlotId]["npc"]["subzone"]
      if x ~= nil and x ~= 0 then
        infoPos = infoPos.."|cff"..colTxt.." (|cff"..colPos..x..", "..y.."|cff"..colTxt..")"
      end
    end
  end

  if costs["money"] == nil then
    costs["money"] = 0
  end

  if costs["money"] > 0 then
    infoCost = gsub(GetCoinTextureString(costs["money"]), "0|t", "-7|t")
    infoCost = infoCost.."\n"
  end
  
  i = 1
  while costs["value"..i] ~= nil do
    infoCost = infoCost..costs["value"..i].." "..costs["link"..i].."\n"
    i = i + 1
  end
  
  if SLSlots[iSlotId]["showcount"] then
    infoCost = GetItemCount(SLSlots[iSlotId]["item"], false, false).." "..SLNames["textPieces"].."\n"
  end

  infoTip = SLSlots[iSlotId]["tip"]

  if infoCost ~= "" then
    _G["SLGroup1"]:Hide()
    _G["SLGroup2"]:Hide()
    _G["SLGroup3"]:Hide()
  end
  _G["SLInfoNpc"]:SetText(infoNpc)
  _G["SLInfoPos"]:SetText(infoPos)
  _G["SLInfoSubPos"]:SetText(infoSubPos)
  _G["SLInfoCost"]:SetText(infoCost)
  _G["SLInfoTip"]:SetText(infoTip)
end

-------------------------------------------------------------------------
--
-- mouse moved from a slot
--
-------------------------------------------------------------------------
function SL_ItemOnLeave( frame )
  GameTooltip:Hide()
  _G["SLInfoNpc"]:SetText("")
  _G["SLInfoPos"]:SetText("")
  _G["SLInfoSubPos"]:SetText("")
  _G["SLInfoCost"]:SetText("")
  _G["SLInfoTip"]:SetText("")
  _G["SLGroup1"]:Show()
  _G["SLGroup2"]:Show()
  _G["SLGroup3"]:Show()
end

-------------------------------------------------------------------------
--
-- dragging startet at a slot
--
-------------------------------------------------------------------------
function SL_ItemOnDrag(frame)
  local iSlotId = tonumber(strsub(frame:GetName(),5))
  local infoType, itemId, itemLink = GetCursorInfo()

  if SLSlots[iSlotId]["item"] ~= "" then
    ClearCursor()
    SLSaveSlot = SLSlots[iSlotId]
    PickupItem(SLSlots[iSlotId]["item"])
    SLDragSlot = iSlotId
    SL_ClearSlot(iSlotId)
    SL_UpdateSlot(iSlotId)
  end
end

-------------------------------------------------------------------------
--
-- changing the current group
--
-------------------------------------------------------------------------
function SL_ChangeGroup(idx)
  if SLSlots ~= nil then
    SL_Deinitialize()
--    SLPlayer["groups"][SLPlayer["CurrentGroup"]..""] = SLSlots
  end
  
  SLPlayer["CurrentGroup"] = idx
  
  if SLPlayer["groups"][idx..""] == nil then
    SLPlayer["groups"][idx..""] = {}
  end 
  
  SLSlots = SLPlayer["groups"][idx..""]

  for iSlotId=1, SLMaxSlots, 1 do
    local v = SLSlots[iSlotId]
    if v == nil then
      SL_ClearSlot(iSlotId)
    end
    SL_UpdateSlot(iSlotId)
  end
  
  for i=1, 3 do
    if idx == i then
      _G["SLGroup"..i]:SetTextColor(255,255,0,1.0)
    else
      _G["SLGroup"..i]:SetTextColor(255,0,0,0.7)
    end
    
  end
  
--  message(format("%s aktivieren", SLNames["textGroup"..idx]))
end